using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Threading;
using System.Globalization;
using Styx;
using Styx.Helpers;
using Styx.Plugins;
using Styx.Plugins.PluginClass;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Styx.Logic.BehaviorTree;
using System.Drawing;
using System.Collections.Specialized;
using Styx.Logic;


namespace PushNotify 
{
    public partial class PushNotify : HBPlugin 
    {
        #region Variables
        public static string settingsPath = Logging.ApplicationPath + @"\Settings\PushNotify Settings\";
        public PNSettings Settings { get; set; }
        public static PushNotify Instance { get; set; }
        private static int startTime;
        private static LocalPlayer Me { get { return ObjectManager.Me; } }
        private static string s = "!@#$";
        private static bool Init;
        private static bool UseLootFilter;
        private static Stopwatch tickTimer = new Stopwatch();
        private static Stopwatch ssTimer = new Stopwatch();
        private static Stopwatch pushTimer = new Stopwatch();
        private static Stopwatch loadTimer = new Stopwatch();
        private Thread th = new Thread(SecondThread) { IsBackground = true, Name = "PushNotify - Updating Data" };
        private static Queue<NameValueCollection> dataQueue = new Queue<NameValueCollection>();
        private static Queue<Notification> pushQueue = new Queue<Notification>();
        private readonly List<string> _names = new List<string>();
        private readonly List<string> _aliases = new List<string>();
        public int LootLevel;
        #endregion
        
        #region Overrides
        public override Version Version { get { return new Version("1.0.1.0"); } }
        public override string Author { get { return "spider2k5"; } }
        public override string ButtonText { get { return "Settings"; } }
        public override string Name { get { return "PushNotify"; } }
        public override bool WantButton { get { return true; } }
        public override void OnButtonPress() { new GUI.FormConfiguration().ShowDialog(); }
        #endregion
      
        #region Constructor
        public PushNotify() 
        {
            Instance = this;
            Settings = new PNSettings();
        }
        #endregion
        
        #region Dispose
        public override void Dispose() 
        {  
            try 
            { 
                if (th.IsAlive) th.Abort(); 
            }
            catch { }
            WoWChat.Whisper -= new WoWChat.ChatMessageHandlerEx<WoWChat.ChatWhisperEventArgs>(WoWChat_Whisper);
            WoWChat.Battleground -= new WoWChat.ChatMessageHandlerEx<WoWChat.ChatLanguageSpecificEventArgs>(WoWChat_Battleground);
            WoWChat.Emote -= new WoWChat.ChatMessageHandlerEx<WoWChat.ChatAuthoredEventArgs>(WoWChat_Emote);
            WoWChat.Guild -= new WoWChat.ChatMessageHandlerEx<WoWChat.ChatGuildEventArgs>(WoWChat_Guild);
            WoWChat.Party -= new WoWChat.ChatMessageHandlerEx<WoWChat.ChatLanguageSpecificEventArgs>(WoWChat_Party);
            WoWChat.PartyLeader -= new WoWChat.ChatMessageHandlerEx<WoWChat.ChatLanguageSpecificEventArgs>(WoWChat_PartyLeader);
            WoWChat.Say -= new WoWChat.ChatMessageHandlerEx<WoWChat.ChatLanguageSpecificEventArgs>(WoWChat_Say);
            WoWChat.TextEmote -= new WoWChat.ChatMessageHandlerEx<WoWChat.ChatAuthoredEventArgs>(WoWChat_TextEmote);
            WoWChat.Yell -= new WoWChat.ChatMessageHandlerEx<WoWChat.ChatLanguageSpecificEventArgs>(WoWChat_Yell);
            BotEvents.Player.OnLevelUp -= new BotEvents.Player.LevelUpDelegate(Player_OnLevelUp);
            BotEvents.Player.OnPlayerDied -= new BotEvents.Player.PlayerDiedDelegate(Player_OnPlayerDied);
            Lua.Events.DetachEvent("CHAT_MSG_BN_WHISPER", HandleBNWhisper);
            Lua.Events.DetachEvent("ARTIFACT_COMPLETE", HandleArcheology);
            Styx.BotEvents.Player.OnMobKilled -= CheckAndBlackList;
            LootTargeting.Instance.IncludeTargetsFilter -= LootsFilter;
            base.Dispose();
        }
        #endregion
      
        #region Initialize
        private void Initialise() 
        {
            _names.Add(StyxWoW.Me.Name.ToLower());
            startTime = Environment.TickCount;
            Init = true;
            Log("PushNotify is succesfully loaded");
            WoWChat.Whisper += WoWChat_Whisper;
            WoWChat.Battleground += WoWChat_Battleground;
            WoWChat.Emote += WoWChat_Emote;
            WoWChat.Guild += WoWChat_Guild;
            WoWChat.Party += WoWChat_Party;
            WoWChat.PartyLeader += WoWChat_PartyLeader;
            WoWChat.Say += WoWChat_Say;
            WoWChat.TextEmote += WoWChat_TextEmote;
            WoWChat.Yell += WoWChat_Yell;
            BotEvents.Player.OnLevelUp += Player_OnLevelUp;
            BotEvents.Player.OnPlayerDied += Player_OnPlayerDied;
            Lua.Events.AttachEvent("CHAT_MSG_BN_WHISPER", HandleBNWhisper);
            Lua.Events.AttachEvent("ARTIFACT_COMPLETE", HandleArcheology);
            Styx.BotEvents.Player.OnMobKilled += CheckAndBlackList;
            LootTargeting.Instance.IncludeTargetsFilter += LootsFilter;
            th.Start();
        }
        #endregion
      
        #region Pulse
        public override void Pulse() 
        { 
            if (!Init) 
            { 
                Initialise(); 
            }
            CheckLootlevel();
        }
        #endregion

        #region Second Thread
        private static bool pushedDisconnect = false;
        private static void SecondThread() 
        {
            Thread.CurrentThread.CurrentCulture = new CultureInfo("en-US");
            while (true) 
            {
                try 
                {
                    Thread.Sleep(100);
                    if (!ObjectManager.IsInGame || Me == null || Me.BaseAddress == 0) 
                    {
                        if (Instance.Settings.PushDisconnect && !pushedDisconnect) 
                        {
                            if (!loadTimer.IsRunning)
                                loadTimer.Start();
                            if (loadTimer.ElapsedMilliseconds >= 20000) 
                            {
                                pushedDisconnect = true;
                                AddNotificationToQueue(String.Format("{0} has been disconnected from game.", Me.Name), "Disconnect !", NMA.NMANotificationPriority.Emergency);
                                SendNotification(pushQueue.Dequeue());
                                loadTimer.Reset();
                            }
                        }
                        tickTimer.Start();
                        continue;
                    }
                    if (tickTimer.IsRunning && tickTimer.ElapsedMilliseconds <= 5000)
                        continue;
                    if (!pushTimer.IsRunning)
                        pushTimer.Start();
                    if (Instance.Settings.PushStatus && pushTimer.Elapsed.Minutes >= Instance.Settings.PushStatusInterval)
                    {
                        pushTimer.Reset();
                        string updateData = String.Format(
                            "Charname: {17}{16}HealthPercent: {0}%{16}PowerPercent: {1}%{16}Level: {2}{16}XP/hour: {3}{16}BG Won/hour: {4}{16}BG Won/Lost: {5}/{6}{16}Mobs Killed: {7}{16}Deaths: {8}{16}Current Zone: {9}{16}Current Subzone: {10}{16}TimeToLevel: {11}{16}Bot Status: {12}{16}Current POI: {13}{16}Durability: {14}%{16}FreeBagSlots: {15}",
                            (byte)Me.HealthPercent, (byte)Me.PowerPercent, Me.Level, InfoPanel.XPPerHour, 
                            InfoPanel.BGsWonPerHour, InfoPanel.BGsWon, InfoPanel.BGsLost,
                            InfoPanel.MobsKilled, InfoPanel.Deaths, Me.ZoneText, Me.SubZoneText, 
                            TimeToLevel, (TreeRoot.IsRunning ? "running" : "stopped"),
                            Styx.Logic.POI.BotPoi.Current.Name, (byte)(Me.DurabilityPercent * 100), 
                            Me.FreeNormalBagSlots, Environment.NewLine, Me.Name);
                        AddNotificationToQueue(updateData, "Status Update", NMA.NMANotificationPriority.Normal);         
                    }
                    pushedDisconnect = false;
                    loadTimer.Reset();
                    tickTimer.Reset();

                    if (pushQueue.Count > 0) 
                    {
                        SendNotification(pushQueue.Dequeue());
                    }
                    string echo = null;

                    if (String.IsNullOrEmpty(echo)) 
                    {
                        tickTimer.Start();
                        continue;
                    }
                    string command = null;
                    string arg1 = null;
                    string arg2 = null;
                    string arg3 = null;

                    if (echo.Contains(s)) 
                    {
                        string[] echoArray = echo.Split(s.ToArray(), StringSplitOptions.RemoveEmptyEntries);
                        command = echoArray[0];
                        arg1 = echoArray.Length > 1 ? echoArray[1] : null;
                        arg2 = echoArray.Length > 2 ? echoArray[2] : null;
                        arg3 = echoArray.Length > 3 ? echoArray[3] : null;
                    } else {
                        command = echo;
                    }
                    if (String.IsNullOrEmpty(command))
                    {
                        tickTimer.Start();
                        continue;
                    }
                    tickTimer.Start();
                }
                catch { }
            }
        }
        #endregion
    }
}
