using System.ComponentModel;

using Styx;
using Styx.Helpers;

using DefaultValue = Styx.Helpers.DefaultValueAttribute;

namespace PushNotify
{
    public class PNSettings : Settings
    {
        public PNSettings()
            : base(PushNotify.settingsPath + @"PNSettings.xml")
        {
            Load();
        }

        ~PNSettings()
        {
            Save();
        }

        [Setting, DefaultValue(5), Category("Mob Level Loot Filter"), DisplayName("Level Offset"), Description("Only Loot mobs X levels below you. If your 85 and enter 5 then PushNotify will only loot mobs >= level 80 (85-5=80)")]
        public int LootFilterOffset { get; set; }

        [Setting, DefaultValue(true), Category("Mob Level Loot Filter"), DisplayName("Enable Filter"), Description("Enable mob level Loot Filtering")]
        public bool UseLootFilter { get; set; }

        [Setting, DefaultValue(""), Category("Targeted Chat Detection"), DisplayName("Alias 1"), Description("Push Notification if Alias name is found with in Chat type")]
        public string PushAlias1 { get; set; }

        [Setting, DefaultValue(""), Category("Targeted Chat Detection"), DisplayName("Alias 2"), Description("Push Notification if Alias name is found with in Chat type")]
        public string PushAlias2 { get; set; }

        [Setting, DefaultValue(""), Category("Targeted Chat Detection"), DisplayName("Alias 3"), Description("Push Notification if Alias name is found with in Chat type")]
        public string PushAlias3 { get; set; }

        [Setting, DefaultValue(""), Category("Targeted Chat Detection"), DisplayName("Alias 4"), Description("Push Notification if Alias name is found with in Chat type")]
        public string PushAlias4 { get; set; }

        [Setting, DefaultValue(""), Category("Targeted Chat Detection"), DisplayName("Alias 5"), Description("Push Notification if Alias name is found with in Chat type")]
        public string PushAlias5 { get; set; }

        [Setting, DefaultValue(""), Category("Targeted Chat Detection"), DisplayName("Alias 6"), Description("Push Notification if Alias name is found with in Chat type")]
        public string PushAlias6 { get; set; }

        [Setting, DefaultValue(""), Category("Targeted Chat Detection"), DisplayName("Alias 7"), Description("Push Notification if Alias name is found with in Chat type")]
        public string PushAlias7 { get; set; }

        [Setting, DefaultValue(""), Category("Targeted Chat Detection"), DisplayName("Alias 8"), Description("Push Notification if Alias name is found with in Chat type")]
        public string PushAlias8 { get; set; }

        [Setting, DefaultValue(""), Category("Targeted Chat Detection"), DisplayName("Alias 9"), Description("Push Notification if Alias name is found with in Chat type")]
        public string PushAlias9 { get; set; }

        [Setting, DefaultValue(""), Category("Targeted Chat Detection"), DisplayName("Alias 10"), Description("Push Notification if Alias name is found with in Chat type")]
        public string PushAlias10 { get; set; }

        [Setting, DefaultValue(false), Category("Targeted Chat Detection"), DisplayName("Yell"), Description("Push only when your named in this type of chat")]
        public bool PushYellOnlyMe { get; set; }

        [Setting, DefaultValue(false), Category("Targeted Chat Detection"), DisplayName("Say"), Description("Push only when your named in this type of chat")]
        public bool PushSayOnlyMe { get; set; }

        [Setting, DefaultValue(false), Category("Targeted Chat Detection"), DisplayName("Party"), Description("Push only when your named in this type of chat")]
        public bool PushPartyOnlyMe { get; set; }

        [Setting, DefaultValue(true), Category("Targeted Chat Detection"), DisplayName("Guild"), Description("Push only when your named in this type of chat")]
        public bool PushGuildOnlyMe { get; set; }

        [Setting, DefaultValue(false), Category("Targeted Chat Detection"), DisplayName("Battleground"), Description("Push only when your named in this type of chat")]
        public bool PushBattlegroundOnlyMe { get; set; }

        [Setting, DefaultValue(""), Category("NMA"), DisplayName("NMA Api Key"), Description("Used while sending push notifications via NMA")]
        public string NMAAPIKEY { get; set; }

        [Setting, DefaultValue(true), Category("NMA"), DisplayName("Send NMA Notifications"), Description("Enable NMA Notifications")]
		public bool UseNMA { get; set; }

		[Setting, DefaultValue(true), Category("Push Notifications - Global"), DisplayName("Whispers"), Description("Push notification when you receive a whisper")]
		public bool PushWhisper { get; set; }

        [Setting, DefaultValue(true), Category("Push Notifications - Global"), DisplayName("BattleNET Whispers"), Description("Push notification when you receive a BattleNET whisper")]
		public bool PushBNWhisper { get; set; }

        [Setting, DefaultValue(true), Category("Push Notifications - Global"), DisplayName("Yell"), Description("Push notification when you receive a yell")]
		public bool PushYell { get; set; }

        [Setting, DefaultValue(true), Category("Push Notifications - Global"), DisplayName("Text Emote"), Description("Push notification when you receive a text emote")]
		public bool PushTextEmote { get; set; }

        [Setting, DefaultValue(true), Category("Push Notifications - Global"), DisplayName("Say"), Description("Push notification when you receive a say message")]
		public bool PushSay { get; set; }

        [Setting, DefaultValue(true), Category("Push Notifications - Global"), DisplayName("Party"), Description("Push notification only when your receive a party message with your name")]
		public bool PushParty { get; set; }

        [Setting, DefaultValue(true), Category("Push Notifications - Global"), DisplayName("Guild"), Description("Push notification when you receive a guild message")]
		public bool PushGuild { get; set; }

        [Setting, DefaultValue(true), Category("Push Notifications - Global"), DisplayName("Emote"), Description("Push notification when you receive an emote")]
		public bool PushEmote { get; set; }

        [Setting, DefaultValue(true), Category("Push Notifications - Global"), DisplayName("Battleground"), Description("Push notification when you receive a battleground message")]
		public bool PushBattleground { get; set; }

        [Setting, DefaultValue(true), Category("Push Notifications - Action"), DisplayName("Archeology Solves"), Description("Push notification when you make an Archeology Solve")]
        public bool PushArchSolve { get; set; }

        [Setting, DefaultValue(true), Category("Push Notifications - Action"), DisplayName("Level Up"), Description("Push notification when you level up")]
        public bool PushLevelUp { get; set; }

        [Setting, DefaultValue(true), Category("Push Notifications - Action"), DisplayName("Die"), Description("Push notification when you die")]
		public bool PushDead { get; set; }

		[Setting, DefaultValue(true), Category("Push Notifications - Action"), DisplayName("Status"), Description("Push status updates")]
		public bool PushStatus { get; set; }

		[Setting, DefaultValue(30), Category("Push Notifications - Action"), DisplayName("Status Interval"), Description("Interval in minutes to send new status")]
		public int PushStatusInterval { get; set; }

		[Setting, DefaultValue(true), Category("Push Notifications - Action"), DisplayName("Disconnect"), Description("Push notification when you are not in game")]
		public bool PushDisconnect { get; set; }
	}
}
